package com.bleujin.thinlet.sample.invocation;

import java.lang.reflect.Proxy;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

public class TestInvoke extends TestCase {

	
	public void testSum() throws Exception {
		
		TestInvoke iv = new TestInvoke() ;
		
//		NumObject n3 = new NumObject(3);
//		NumObject n5 = new NumObject(5);
		
		NumObject no3 = new NumObject(3);
		NumObject no5 = new NumObject(5);
		
		INum n3 = (INum)Proxy.newProxyInstance(new SimpleClassLoader(""), no3.getClass().getInterfaces(), new NumObjectHandler(no3)) ;
		INum n5 = (INum)Proxy.newProxyInstance(new SimpleClassLoader(""), no5.getClass().getInterfaces(), new NumObjectHandler(no5)) ;
		
		iv.add(n3);
		iv.add(n5);
		
		assertEquals(8, iv.sum()) ;
	}
	
	
	private int sum() {
		int result = 0 ;
		for (Object obj : data) {
			result += ((INum)obj).getValue() ;
		}
		return result;
	}


	private List<Object> data = new ArrayList<Object>() ; 
	private void add(INum numObject) {
		data.add(numObject) ;
	}


}

